<template>
	<v-divider
		class="border-opacity-100"
		color="#E4E4E4"
		:thickness="2"
	></v-divider>
	<v-container class="mx-auto pt-9 pb-12">
		<v-row class="mt-0">
			<v-col cols="8">
				<v-row>
					<v-col cols="6">
						<v-card-text class="pa-0">
							<v-text-field
								density="compact"
								variant="outlined"
								color="#E4E4E4"
								base-color="E4E4E4"
								label="Search make"
								append-inner-icon="mdi-magnify"
								single-line
								hide-details
								rounded="8"
								v-model="searchByMake"
							>
							</v-text-field>
						</v-card-text>
					</v-col>
					<v-col cols="5">
						<v-row class="d-flex align-center">
							<v-col cols="8">
								<v-sheet> Select vehicles per page: </v-sheet>
							</v-col>
							<v-col cols="4">
								<v-select
									fixed
									v-model="selectValue"
									:items="items"
									class="pa-0 ma-0 w-100"
									density="compact"
									type="number"
									color="#E4E4E4"
									variant="outlined"
									hide-spin-buttons
									hide-details
								>
								</v-select>
							</v-col>
						</v-row>
					</v-col>
				</v-row>
			</v-col>
			<v-spacer></v-spacer>
			<v-col class="text-right" cols="2">
				<v-btn
					class="btn__add"
					color="#D90E32"
					height="42"
					rounded="lg"
					@click="$router.push('/create-vehicles')"
				>
					<v-icon></v-icon>
					Add vehicles
				</v-btn>
			</v-col>
		</v-row>

		<v-sheet max-height="1340">
			<v-row
				color="#F3F6F8"
				class="pt-8 mt-0"
				v-if="getSearchByMake(searchByMake).length"
			>
				<v-col
					@click="openCarPage(car.id)"
					v-for="car in getSearchByMake(searchByMake, selectValue)"
					:key="car.id"
					rows="12"
					sm="4"
				>
					<v-hover>
						<v-card
							@click="$router.push(`/vehicles/${id}`)"
							color="#F3F6F8"
							class="pa-6"
							rounded="lg"
						>
							<div class="d-flex justify-end">
								<v-btn
									@click.stop
									active
									flat
									variant="plain"
									:ripple="false"
									color="#293148"
								>
									<v-img src="@/assets/icons/more-horizontal.svg"></v-img>
								</v-btn>
							</div>
							<div>
								<!-- <v-img cover height="135" :src="'../assets/img/' + car.img" alt="img"></v-img> -->
								<v-img :src="require(`../assets/img/${car.img}`)"></v-img>
							</div>
							<v-card-title class="pa-0 pt-6 d-flex ga-1">
								<span>{{ car?.make || 'No Name' }}</span>
								<span>{{ car?.model || '' }}</span>
							</v-card-title>
							<v-card-subtitle class="pa-0 pt-3 pb-4">{{
								car?.vin || 'No vin'
							}}</v-card-subtitle>
							<v-divider
								class="border-opacity-100"
								color="#E4E4E4"
								:thickness="2"
							></v-divider>
							<div class="d-flex justify-space-between pt-4">
								<v-chip color="#7FC75E">
									<v-icon class="pr-2">mdi-check</v-icon>
									<span>{{ car?.number || 0 }}/30</span>
								</v-chip>
								<span>3 days left</span>
							</div>
						</v-card>
					</v-hover>
				</v-col>
			</v-row>
			<h4 v-else>Car is not found!</h4>
		</v-sheet>

		<Pagination
			:allUsersPage="getAllCars.length"
			:allPageOfTheTable="getCountAllPagesWithCars"
			:itemsPerPage="carPerPage"
			@setCurrentPage="setCurrentPage"
		/>
	</v-container>
</template>

<script>
import Pagination from '@/components/Pagination.vue'
import { mapGetters } from 'vuex'

export default {
	name: 'VehiclesPage',
	components: {
		Pagination,
	},
	data() {
		return {
			searchByMake: '',
			selectValue: '10',
			items: [10, 20, 30, 40],
		}
	},
	computed: {
		...mapGetters([
			'getAllCars',
			'getSearchByMake',
			'getCountAllPagesWithCars',
			'carPerPage',
			'getCurrentPageCars',
			'getCarsByQuantity',
		]),
	},
	methods: {
		openCarPage(id) {
			this.$router.push(`/vehicles/${id}`)
		},
		setCurrentPage(page) {
			this.getCurrentPageCars(page)
		},
	},
}
</script>
